#define DEBUG_TYPE "analysis_pass"

#include "llvm/Pass.h"

#include "llvm/Support/CommandLine.h"
#include "llvm/Support/raw_ostream.h"

using namespace llvm;

extern cl::opt<int> CommandLineOption;

namespace {
  class AnalysisPass : public FunctionPass {
  public:
    static char ID;
    AnalysisPass ();
    virtual bool runOnFunction(Function &F);
    virtual void getAnalysisUsage(AnalysisUsage &AU) const;
  };
}

AnalysisPass::AnalysisPass() : FunctionPass(ID) {
}

bool AnalysisPass::runOnFunction(Function &F) {
  llvm::errs() << "Running Dummy Pass.\nCL option value: " << 
    CommandLineOption << "\n";
  return false;
}

void AnalysisPass::getAnalysisUsage(AnalysisUsage &AU) const {
  AU.setPreservesAll();
}

char AnalysisPass::ID = 0;
static RegisterPass<AnalysisPass> X("ap", "Dummy analysis pass");
