#define DEBUG_TYPE "transform_pass"

#include "llvm/Pass.h"

#include "llvm/Support/CommandLine.h"
#include "llvm/Support/raw_ostream.h"

using namespace llvm;

extern cl::opt<int> CommandLineOption;

namespace {
  class TransformPass : public FunctionPass {
  public:
    static char ID;
    TransformPass ();
    virtual bool runOnFunction(Function &F);
    virtual void getAnalysisUsage(AnalysisUsage &AU) const;
  };
}

TransformPass::TransformPass() : FunctionPass(ID) {
}

bool TransformPass::runOnFunction(Function &F) {
  llvm::errs() << "Running Transform Pass.\nCL option value: " << 
    CommandLineOption << "\n";
  return false;
}

void TransformPass::getAnalysisUsage(AnalysisUsage &AU) const {
  AU.setPreservesAll();
}

char TransformPass::ID = 0;
static RegisterPass<TransformPass> X("tp", "Dummy transform pass");
